<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
# This file is part of fpdf4dc2, a plugin for Dotclear 2.
# 
# écrit par R. Hackert  remi.hackert(at)wanadoo.fr
# 
# Licensed under the GPL version 2.0 license.
# A copy of this license is available in LICENSE file or at
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# -- END LICENSE BLOCK ------------------------------------

if (!defined('DC_RC_PATH')){return;}
global $core;

// on créer les tpl pour l'incrustation d'un bouton demandant le pdf du post,de la categorie ou du blog
// c'est l'url de la page appelante qui dira si on veut le pdf d'un post , d'une categorie ou tout le blog
// utilisation: par exemple rajouter {{tpl:PdfRequestButton}} dans post.php

$core->tpl->addValue('PdfRequestButton', array('tplMesTplSupp','PdfRequestButton'));

class tplMesTplSupp
{
 	public static function PdfRequestButton()
	{
	 global $core;	
	 return '<a href="<?php echo $core->blog->url;?>fpdf4dc2/<?php echo $core->blog->id;?>">
		<img class="pdfrequestbutton" src="themes/<?php echo $core->blog->settings->system->theme;?>/img/pdf.jpg" alt="pdf.jpg"/></a>'; 
	}	 
		
}
 

// on crée l'url fpdf4dc2: quand elle est detectée dotclear appelle la fonction dopdf.
$core->url->register('fpdf4dc2','fpdf4dc2','^fpdf4dc2(?:/(.+))?$',array('dopdfURL','dopdf'));


class dopdfURL extends dcUrlHandlers
{        
    public static function dopdf($args)
    {
		
		    define('FPDF_FONTPATH','font/');
	 
	// on recupere l'URL appelante 
	$urlorigine = $_SERVER['HTTP_REFERER'];
    // echo $urlorigine;
	// on recupère le nom du blog sur lequel on doit aller se servir
	$nomdublog = $args; 

    global $core;
	global $servername;	
	global $blogurl;
	global $fblogurl;
    global $y_image_bottom;
    global $pdf_name;
    global $typeofcover;
    global $couverture;
    global $pagedegarde;
    
    
    global $ccol;
    global $coltop;
    global $goutt;
    global $ncol;
    global $colwidth;
    global $il;
    
    //lmel=les mois en lettre
    global $jour;
    global $mois;
    global $annee;
    $lmel = array('janvier', 'fevrier', 'mars', 'avril', 'mai', 'juin', 'juillet', 'aout', 'septembre', 'octobre', 'novembre', 'decembre');
    
    
    
    //en attendant de lui donner un vrai nom
    $pdf_name = '';
    $coverstring='';
    $il=5;
   
    
    //recuperation des settings de la page d'admin
    include dirname(__FILE__).'/recup_settings_page_admin.php';

    

    $servername = $_SERVER['SERVER_NAME'];

    
    $ccol=1;
    $coltop=$mh;
    $colwidth= ($lp-$md-$mg-($ncol-1)*$goutt)/$ncol;

    // Indication du blog à utiliser
	$core->setBlog($nomdublog);

	// query string alors url du blog moins index.php sinon rien à couper 
	if ($core->blog->system->url_scan == "query_string"){
		//alors deux possibilités soit cela finit par index.php?
	    if (strstr($core->blog->url,'index.php')) { 
		   $blogurl= substr($core->blog->url,0,-10); 
		   // fblogurl contient l'url du blog determine a partir de $urlorigine c'est a dire potentiellemnt apres une redirection
    	   // important pour Curl sinon probleme quand les safe mode sont sur 1 
	       $fblogurl=substr($urlorigine,0,strripos($urlorigine,'index.php')-1);
	    } else {
		  // url finit par /? sans le 'index.php'
		   $blogurl= substr($core->blog->url,0,-1);
		   $fblogurl=substr($urlorigine,0,strripos($urlorigine,'/?')-1);
	    }
	} else {
	  //on est en pathmode on enleve juste index.php/	
	    $blogurl = substr($core->blog->url,0,-10); 
	    $fblogurl= substr($urlorigine,0,strripos($urlorigine,'index.php')-1);
	    
	}


   //on est coté public, plusieurs cas se presente 
   //on recherche si l'url provient d'une page de post, de page statique, de categorie ou de tag
	

	 // si l'url contient la chaine "?post",(query-string) 
	 // alors il s'agit d'un billet
	  if ( strstr($urlorigine,'?post') ) { 
	  	   // on recupere la partie de l'URL apres "post"
	 	    $urldupost=substr($urlorigine,strripos($urlorigine,'?post')+6); 
		    $params['sql'] = "AND post_url = '{$urldupost}' " ;
		    $pdf_name = str_replace('/','-',remove_accent($urldupost));
		    $selection = false;
	  }
	  
	   // si l'url contient la chaine ou /post (path_info) 
	  if ( strstr($urlorigine,'/post/')) { 
	  	   // on recupere la partie de l'URL apres "post"
	 	    $urldupost=substr($urlorigine,strripos($urlorigine,'/post/')+6); 
		    $params['sql'] = "AND post_url = '{$urldupost}' " ;
		    $pdf_name = str_replace('/','-',remove_accent($urldupost));
		    $selection = false;
	  }
	  
	  
	  // si l'url contient la chaine "category", il s'agit de ...categorie
	  if (strstr($urlorigine,'category')) { 
        	// on recupere la partie de l'url apres "category/" 
	        $nomcategory=substr($urlorigine,strripos($urlorigine,'category')+9);
		    $params['cat_url'] = $nomcategory;
		    $pdf_name = $nomcategory;
		    $selection = true;
		    $coverstring=$nomcategory;
	   }
 
	   // si l'url contient la chaine "?page", il s'agit d'une page statique
	   if (strstr($urlorigine,'?page')) { 
		    $params ['post_type'] = "page";
            // on recupere la partie de l'url apres "page" 
	        $urldupost=substr($urlorigine,strripos($urlorigine,'?page')+6);
		    $params['sql'] = "AND post_url = '{$urldupost}' " ;
		    $pdf_name = str_replace('/','-',remove_accent($urldupost));
		    $selection = true;
 	   }
 
       if (strstr($urlorigine,'/page/')) { 
		    $params ['post_type'] = "page";
            // on recupere la partie de l'url apres "page" 
	        $urldupost=substr($urlorigine,strripos($urlorigine,'/page/')+6);
		    $params['sql'] = "AND post_url = '{$urldupost}' " ;
		    $pdf_name = str_replace('/','-',remove_accent($urldupost));
		    $selection = true;
 	   }
 

 	   // si l'url contient la chaine "?tag", il s'agit d'une selection sur la base d'un mot cle
	   if (strstr($urlorigine,'?tag')) {
		    $tagvalue=substr($urlorigine,strripos($urlorigine,'?tag')+5);
		    $params['meta_id'] = $tagvalue ;
		    $params['meta_type'] = 'tag';
		    $pdf_name = trim($tagvalue);
            $selection = true;
            $coverstring=$tagvalue;
 	   }

 	   if (strstr($urlorigine,'/tag')) {
		    $tagvalue=substr($urlorigine,strripos($urlorigine,'/tag')+5);
		    $params['meta_id'] = $tagvalue ;
		    $params['meta_type'] = 'tag';
		    $pdf_name = trim($tagvalue);
            $selection = true;
 	   }
	
	
 	   // On sélectionne les posts en base de données...
	   $_ctx = new context();
       $_ctx->post_params = $params;
       if (strstr($urlorigine,'?tag')) {
		    $_ctx->posts = $core->meta->getPostsByMeta($params); }
       else {
		    $_ctx->posts = $core->blog->getPosts($params); }
       unset($params);
    
	   // ... et on peu commencer
	   $pdf= new PDF_HTML('P', 'mm', $fp);  // portrait, unit, format page
	   
	   //valeur par default
	   $pdf->SetFont($tff,'',$tfs);
	   
	   
	   if ($couverture) {
	       switch ($typeofcover) { 
		   
		   case 'Page vide':
				$pdf->Addpage(); 
				
				break;
				
		   case 'Bauhaus' : 
				$pdf->Addpage();
				$pdf->SetFont('Arial','B',40);
				
				//eparpillement de rectangle aleatoire
				for ($i=1;$i<30; $i++) {
				$rx0=rand(0,200);
				$ry0=rand(0,290);
				$rw=rand(1,210);
				$rh=rand(1,290);
				$C1=rand(50,255);
				$C2=rand(50,255);
				$C3=rand(50,255);
				$pdf->SetFillColor($C1,$C2,$C3);
				$pdf->Rect($rx0,$ry0,$rx0+$rw,$ry0+$rh,'F');	
				}	
				$pdf->SetXY(55,140);
				$st = mb_convert_encoding($coverstring, "Windows-1252", "UTF-8");
				$pdf->Write(2,$st);
			//	$pdf->SetXY(55,73);
			//	$pdf->Write(2,'EN');
			//	$pdf->SetXY(55,96);
			//	$pdf->Write(2,'COMMUN');
	
                if (($aveclogo) && ((file_exists($pathtologo)) || (file_exists('../'.$pathtologo))) ) {		
        	       $pdf->Image($pathtologo,70,80,70,0,'jpg', $core->blog->url); }
				break;
				  
		   case 'Collage' : 
				$pdf->Addpage();
				
				$pdf->SetFillColor( hexdec("#FF"),hexdec("#99"), hexdec("#01"));
				$pdf->Rect(0,0,$lp,60,'F');
				$pdf->SetFillColor(200,200,200);
				$pdf->Rect(0,60,$lp,$hp-100,'F');

				$pdf->SetFillColor( hexdec("#FF"),hexdec("#99"), hexdec("#01"));
				$pdf->Rect(0,$hp-40,$lp,40,'F');
				$pdf->SetXY(15,35);
				$pdf->SetTextColor(255,255,255);
				$pdf->SetFont('Arial','B',70);
				$pdf->Write(0,"MeC");	
				$pdf->SetFont('Arial','',24);
				$pdf->SetXY($lp-55,55);
				setlocale(LC_TIME,'fr_FR','french','French_France.1252','fr_FR.ISO8859-1','fra');
			//	date_default_timezone_set('Europe/Paris');
				$pdf->Write(0,strftime('%B %Y'));	
				
		        break; 
		   }
	   }	   
	   
	   if ($pagedegarde)  { $pdf->AddPage(); }
	   
	   include dirname(__FILE__).'/create_PDF_header_sommaire.php';
	   
	   while ($_ctx->posts->fetch() ) {	 

         // pour chaque billet recuperation des données: titre, extrait et corps       
       	 // on récupère les données de la table post
		 $resume  = $_ctx->posts->post_excerpt_xhtml;
   		 $corps   = $_ctx->posts->post_content_xhtml; 
         $titre   = $_ctx->posts->post_title;
         $date    = $_ctx->posts->post_dt;
         
         //on transforme la date de 2021-05-12 en 12 mai 2021 
         $jour = str_replace('-','',substr($date,8,2)); 
         $mois = $lmel[intval(str_replace('-','',substr($date,5,2)))-1];
         $annee = substr($date,0,4);
         
         // recuperation de la category du post
         $cat= $core->blog->getCategory($_ctx->posts->cat_id);
         $category = $cat->cat_title;
         
		 // on récupère le nom et prenom dans la table user
   		 $rs= $core->getUser($_ctx->posts->user_id);
         $auteurdate = 'Par '.stripslashes(utf8_decode($rs->user_firstname)).' '.stripslashes(utf8_decode($rs->user_name));
       
         
       
         // ecriture du billet et completion du sommaire si souhaité 
         //  NB: partie commune avec le script cote post admin
         //include dirname(__FILE__).'/create_PDF_sommaire_plus_billets.php';
         $resume = mb_convert_encoding( $resume, "Windows-1252", "UTF-8");
         $corps  = mb_convert_encoding( $corps , "Windows-1252", "UTF-8"); 
         $titre  = mb_convert_encoding( $titre , "Windows-1252", "UTF-8");
         $category=mb_convert_encoding( $category , "Windows-1252", "UTF-8");
          	        	   	
	     //si choisit par l'utilisateur on inscit le titre dans le sommaire.
         if ($sommaire && $selection) {	
		    //pour cela on stocke la page et position actuelle
		    $pageactuelle = $pdf->PageNo() ;
		   
		    
            // on se rend sur la page du sommaire
            $pdf->SetPage($pagedusommaire);
            $pdf->SetMargins($mg,$mh,$md);
            $pdf->SetY($positionYsommaire);
            $pdf->SetX($positionXsommaire);
        
            // on y inscrit le titre et la page 
            $pdf->SetFont($mtff,'B',$stfs);
		    $pdf->SetTextColor(0,102,153) ;
	        $pdf->Ln(2*$il); 
	        $pagenum = $pageactuelle + 1  ;
	        
	        //avant d'ecrire pendant qu'on y est ,on ajoute un lien vers la page
	        $linkref = $pdf->AddLink();
	        $pdf->SetLink($linkref,-1,$pagenum);
	        // et on ecrit
	        $pdf->Write($il,$titre.'. . .   p'.$pagenum,$linkref);	
		
		    // on stocke la nouvelle position
		    $positionYsommaire=$pdf->GetY();
            $positionXsommaire=$pdf->GetX();
            
		    //et on revient à la position actuelle dans le document
	        $pdf->SetPage($pageactuelle);
	       
		
		}
	   	
	   	// et c'est parti!
	   	 $pdf->AddPage();
	     
	     $pdf->SetMargins($mg,$mh,$md);
	     $pdf->SetAutoPageBreak(1,$mb);
	     $y_image_bottom=0 ;
	     
	     if(!$selection) {  $pdf->SetTextColor(0,102,153) ; $pdf->SetFont($mtff,'',$stfs);}

	   	 $evodmg=($mg*($pdf->PageNo()%2))+($md*(1-($pdf->PageNo()%2)));

         $pdf->SetFillColor( hexdec("#FF"),hexdec("#99"), hexdec("#01"));
         $pdf->Rect(0,0,$evodmg+$colwidth,$mh/2,"F");	
         $pdf->SetTextColor(255,255,255);
         $pdf->SetXY($evodmg, 10);
	   	 $pdf->Write(0,$category);
	   	 $pdf->Ln(3*$il);
	   	 $pdf->SetTextColor(200,200,200);
	   	 $pdf->SetFont($aff,'B',$afs);
         $pdf->Write(0,$jour.' '.$mois.' '.$annee);
         $pdf->Ln($il);

      //   $pdf->Rect($evodmg,$pdf->GetY()+$il,$pdf->GetStringWidth($category)+1,0.5,"F");	
	     $ccol=1;
	    
	    
   		 // Si logo.jpg existe dans le repertoire image du theme, alors il est affiché en haut à gauche.
	   	 // avec un lien vers l' URL du blog.
         if (!$sommaire) {
           if (  ($aveclogo) && ((file_exists($pathtologo)) || (file_exists('../'.$pathtologo))) ) {		
    	       $pdf->Image($pathtologo,$logoposx,$logoposy,$logowidth,0,'jpg', $core->blog->url); 
 	       } else { 
	     //sinon on ecrit simplement le nom du blog
		    $pdf->SetFont($tff,'B',$tfs);
		    $pdf->SetTextColor(150,0,70);
	        $pdf->WriteHTML($blogurl);
	        }
	     }

		  // Titre		 
	  	  $pdf->SetFont( $mtff,'B',$mtfs);
	  	  $pdf->SetTextColor(0,102,153);
  		  $evodmg= $mg*($pdf->PageNo()%2)+$md*(1-($pdf->PageNo()%2));
          $pdf->SetLeftMargin($evodmg);
  		  $pdf->Write($il+3,$titre);
	      $pdf->Ln(3*$il); 
          
		  // Auteur 
          // $pdf->SetFontSize(9);
          // $pdf->SetTextColor(255,153,0);
	      // $pdf->Ln(6);
          // $pdf->SetLeftMargin(45);
  	      // $pdf->WriteHTML($auteurdate);
	      // $pdf->Ln(10);
        
         // si multicolonne on le demarre ici
         if ($ncol>1) {
		   $ccol=1;	 
           $pdf->SetColMargin($ccol);
         // on memorise position du haut de la colonne  
           $pdf->Ln($il);
           $coltop=$pdf->GetY();
           

         }
           
         // Resume
         $pdf->SetTextColor(0,0,0);
		 $pdf->SetFont($tff,'',$tfs);
		 if ($resume<>''){  
	        $pdf->WriteHTML($resume);
	        $pdf->Ln($il); 
	     } 

	  	// Corps du texte
	  	
         //essai rendre compact en multiclonne en ajustant la marge du bas
         // pour pousser le remplissage des colonnes
         
         // wordwrap($corps,350)).'  ';
         if ($ncol>1) {
           $posy=$pdf->GetY(); 
           $corps2=$corps;
           $corps2=strip_tags($corps2,"<b><u><i><a><img><p><br><code><strong><em><font><tr><blockquote><h1><h2><h3><h4><h5><h6><li><ul><figure><figcaption><section>");   
           $nb=$pdf->WordWrap($corps2,$colwidth);
           $nl=(1.2+0.25*abs($ncol-3))*$nb/$ncol;
           if(($pdf->GetY()+$il*$nl)<($hp-$mb)){ 
			 $pdf->SetAutoPageBreak(1,$hp-$posy-$il*$nl);
	       } else { 
			 $pdf->SetAutoPageBreak(1,$mb);
		   }
	     }
         $pdf->WriteHTML($corps);
         $pdf->SetAutoPageBreak(1,$mb);
         
       } 
 	   
 	  // et on livre le pdf
	  $pdf->Output();

}

}  // end of class tplMesTplSupp

include dirname(__FILE__).'/classePDF_HTML.php';
include dirname(__FILE__).'/PDF_Bookmark.php';

?>
