<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
# This file is part of fpdf4dc2, a plugin for Dotclear 2.
# 
# Copyright (c) 2012 R Hackert and contributors
# remi.hackert(at)wanadoo.fr
# 
# Licensed under the GPL version 2.0 license.
# A copy of this license is available in LICENSE file or at
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# -- END LICENSE BLOCK ------------------------------------



if (!defined('DC_CONTEXT_ADMIN')){return;}

$default_tab = 'Fonctionnalites';
$core->blog->settings->addNameSpace('fpdf4dc2');
$setfpdf4dc2 =& $core->blog->settings->fpdf4dc2;


$PageStdFormat = array( 'A4 210x297' =>1,'A5 148x210'=>2,'A6'=>3,'Letter'=>4,'HA4 297x297'=>5, 'LA4 210x210'=>6, 'LA5 148x148'=>7 );
$PageStdHauteur =  array(297, 210, 148, 279, 297, 210, 148);
$PageStdLargeur =  array(210, 148, 105, 216, 297, 210, 148);
$PageFmtName=array('a4','a5','a6','letter','ha4','la4','ha5');

$FontFamily = array ('ARIAL'=>'Arial', 'COURRIER'=>'Courier', 'TIMES'=>'Times', 'HELVETICA'=>'Helvetica'); 
$TypeOfCover = array ('Page vide' =>'Page vide', 'Bauhaus' =>'Bauhaus','Collage' =>'Collage');

$fpdf4dc2_margedroite =$setfpdf4dc2->fpdf4dc2_margedroite; 
$fpdf4dc2_margegauche =$setfpdf4dc2->fpdf4dc2_margegauche;
$fpdf4dc2_margehaute  =$setfpdf4dc2->fpdf4dc2_margehaute;
$fpdf4dc2_margebasse  =$setfpdf4dc2->fpdf4dc2_margebasse;
$fpdf4dc2_MainTitleFS = $setfpdf4dc2->fpdf4dc2_MainTitleFS;
$fpdf4dc2_AuthorFS = $setfpdf4dc2->fpdf4dc2_AuthorFS;
$fpdf4dc2_SectionTitleFS = $setfpdf4dc2->fpdf4dc2_SectionTitleFS;
$fpdf4dc2_TextFS = $setfpdf4dc2->fpdf4dc2_TextFS;
$fpdf4dc2_MainTitleFF = $setfpdf4dc2->fpdf4dc2_MainTitleFF;
$fpdf4dc2_AuthorFF = $setfpdf4dc2->fpdf4dc2_AuthorFF;
$fpdf4dc2_SectionTitleFF = $setfpdf4dc2->fpdf4dc2_SectionTitleFF;
$fpdf4dc2_TextFF = $setfpdf4dc2->fpdf4dc2_TextFF;
$fpdf4dc2_interligne = $setfpdf4dc2->fpdf4dc2_interligne;
$fpdf4dc2_logoposx = $setfpdf4dc2->fpdf4dc2_logoposx; 
$fpdf4dc2_logoposy = $setfpdf4dc2->fpdf4dc2_logoposy;
$fpdf4dc2_logowidth = $setfpdf4dc2->fpdf4dc2_logowidth;
$fpdf4dc2_pathtologo = $setfpdf4dc2->fpdf4dc2_pathtologo;
$fpdf4dc2_typeofcover = $setfpdf4dc2->fpdf4dc2_typeofcover;
$fpdf4dc2_ncol = $setfpdf4dc2->fpdf4dc2_ncol;
$fpdf4dc2_goutt = $setfpdf4dc2->fpdf4dc2_goutt;

if (!empty($_POST['save_fonction'])) {
	
	$setfpdf4dc2->put('fpdf4dc2_active',!empty($_POST['fpdf4dc2_active']), 'boolean','Activer le plugin fpdf4dc2');
    $setfpdf4dc2->put('fpdf4dc2_sommaireactif',!empty($_POST['fpdf4dc2_sommaireactif']), 'boolean','pdf avec sommaire');
    $setfpdf4dc2->put('fpdf4dc2_aveclogo',!empty($_POST['fpdf4dc2_aveclogo']), 'boolean','pdf avec logo');
    $setfpdf4dc2->put('fpdf4dc2_pagedegarde',!empty($_POST['fpdf4dc2_pagedegarde']), 'boolean','page de garde');
    $setfpdf4dc2->put('fpdf4dc2_couverture',!empty($_POST['fpdf4dc2_couverture']), 'boolean','page de couverture');

# redirect to the page, avoid conflicts with old settings
	http::redirect($p_url.'&saveconfig=1');
}
 
if (!empty($_POST['savemep'])) {
	$setfpdf4dc2->put('fpdf4dc2_formatpage', $_POST['fpdf4dc2_formatpage'], 'integer','Format page en mm');
	$setfpdf4dc2->put('fpdf4dc2_hauteurpage', $PageStdHauteur[$_POST['fpdf4dc2_formatpage']-1], 'integer','Hauteur page en mm');
    $setfpdf4dc2->put('fpdf4dc2_largeurpage', $PageStdLargeur[$_POST['fpdf4dc2_formatpage']-1], 'integer','Largeur page en mm');
    $setfpdf4dc2->put('fpdf4dc2_margegauche',$_POST['fpdf4dc2_margegauche'], 'integer','Marge gauche en mm');
	$setfpdf4dc2->put('fpdf4dc2_margedroite',$_POST['fpdf4dc2_margedroite'], 'integer','Marge droite en mm');
	$setfpdf4dc2->put('fpdf4dc2_margehaute', $_POST['fpdf4dc2_margehaute'] , 'integer','Marge haute en mm');					
	$setfpdf4dc2->put('fpdf4dc2_margebasse', $_POST['fpdf4dc2_margebasse'] , 'integer','Marge basse en mm');	
	$setfpdf4dc2->put('fpdf4dc2_MainTitleFS',$_POST['fpdf4dc2_MainTitleFS'], 'integer','Title Font size in pt ');
	$setfpdf4dc2->put('fpdf4dc2_AuthorFS',$_POST['fpdf4dc2_AuthorFS'], 'integer','Author Font size in pt');
	$setfpdf4dc2->put('fpdf4dc2_SectionTitleFS', $_POST['fpdf4dc2_SectionTitleFS'] , 'integer','Section Title Font size in pt');					
	$setfpdf4dc2->put('fpdf4dc2_TextFS', $_POST['fpdf4dc2_TextFS'] , 'integer','Text Font size in pt');	
	$setfpdf4dc2->put('fpdf4dc2_MainTitleFF',$_POST['fpdf4dc2_MainTitleFF'] , 'string','Title Font Family');
	$setfpdf4dc2->put('fpdf4dc2_AuthorFF', $_POST['fpdf4dc2_AuthorFF'], 'string','Author Font Family');
	$setfpdf4dc2->put('fpdf4dc2_SectionTitleFF', $_POST['fpdf4dc2_SectionTitleFF'] , 'string','Section Title Font Family');					
	$setfpdf4dc2->put('fpdf4dc2_TextFF',   $_POST['fpdf4dc2_TextFF'], 'string','Text Font Family');	
	$setfpdf4dc2->put('fpdf4dc2_interligne', $_POST['fpdf4dc2_interligne'] , 'integer','Interligne en mm');	
	$setfpdf4dc2->put('fpdf4dc2_logoposx', $_POST['fpdf4dc2_logoposx'], 'integer','Logo position / margegauche en mm');
	$setfpdf4dc2->put('fpdf4dc2_logoposy', $_POST['fpdf4dc2_logoposy'], 'integer','Logo position / marge haute en mm');
	$setfpdf4dc2->put('fpdf4dc2_logowidth',$_POST['fpdf4dc2_logowidth'], 'integer','Largeur du logo en mm');
    $setfpdf4dc2->put('fpdf4dc2_pathtologo', $_POST['fpdf4dc2_pathtologo'], 'string','Chemin vers le fichier du logo');
    $setfpdf4dc2->put('fpdf4dc2_typeofcover', $_POST['fpdf4dc2_typeofcover'], 'string','Type de couverture');
    $setfpdf4dc2->put('fpdf4dc2_ncol', $_POST['fpdf4dc2_ncol'] , 'integer','Nombre de colonnes');	
    $setfpdf4dc2->put('fpdf4dc2_goutt', $_POST['fpdf4dc2_goutt'] , 'integer','Gouttiere en mm');	
 
	# redirect to the page, avoid conflicts with old settings
	http::redirect($p_url.'&saveconfig=1');
}
		
 
if (isset($_GET['saveconfig']))
{
	dcPage::addSuccessNotice(__('Settings have been successfully updated.'));
    http::redirect($p_url);
}
 
?>

<html>
<head>
	<?php echo dcPage::jsPageTabs($default_tab); ?>
	<title><?php echo(__('fpdf4dc2')); ?></title>
</head>


<body>	

<h2><?php echo html::escapeHTML($core->blog->name).' &rsaquo; '.
		__('Fpdf for Dotclear 2'); ?></h2>

<div class="multi-part" id="Misenpage" title="<?php echo __('Mise en page'); ?>">

<form method="post" action="<?php echo($p_url); ?>" >
<br/>
<fieldset>
<legend><b>Format de la Page:</b></legend>


<p><label><?php echo(__('Format de la page')); ?></label>
<?php echo(form::combo('fpdf4dc2_formatpage',$PageStdFormat, $setfpdf4dc2->fpdf4dc2_formatpage )); ?>
</p>


</fieldset>

<br/><br/>
<table style="width:400px">
<tr><td>
<fieldset>
	
	<legend><b>Marge de la page</b></legend>
<p>
	<label><?php echo(__('Marge gauche en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_margegauche',5,255,$fpdf4dc2_margegauche,' ')); ?>
</p>
<p>
	<label><?php echo(__('Marge droite en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_margedroite',5,255,$fpdf4dc2_margedroite,' ')); ?>
</p>
<p>
	<label><?php echo(__('Marge haut en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_margehaute',5,255,$fpdf4dc2_margehaute,' ')); ?>
</p>
<p>
	<label><?php echo(__('Marge bas en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_margebasse',5,255,$fpdf4dc2_margebasse,' ')); ?>
</p>


</fieldset>
</td><td> <fieldset>
	
	<legend><b>Multicolonne</b></legend>
	
	<p>
	<label><?php echo(__('Nombre de colonnes :')); ?></label>
	<?php echo(form::field('fpdf4dc2_ncol',5,255,$fpdf4dc2_ncol,' ')); ?>
</p>
<p>
	<label><?php echo(__('Gouttiere en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_goutt',5,255,$fpdf4dc2_goutt,' ')); ?>
</p>
	
	</td>
</tr>
</table>
<br/><br/>

<fieldset>
	
	<legend><b>Fontes de caracteres utilisée</b></legend>

<p>
	<label><?php echo(__('Titre article:')); ?></label>
	<?php echo(form::combo('fpdf4dc2_MainTitleFF',$FontFamily,$fpdf4dc2_MainTitleFF)); ?><?php echo(form::field('fpdf4dc2_MainTitleFS',3,255,$fpdf4dc2_MainTitleFS,' ')); ?>	
</p>

<p>
	<label><?php echo(__('Auteur et date')); ?></label>
	<?php echo(form::combo('fpdf4dc2_AuthorFF',$FontFamily,$fpdf4dc2_AuthorFF)); ?><?php echo(form::field('fpdf4dc2_AuthorFS',3,255,$fpdf4dc2_AuthorFS,' ')); ?>
</p>

<p>
	<label><?php echo(__('Titre de section:')); ?></label>
	<?php echo(form::combo('fpdf4dc2_SectionTitleFF',$FontFamily,$fpdf4dc2_SectionTitleFF)); ?><?php echo(form::field('fpdf4dc2_SectionTitleFS',3,255,$fpdf4dc2_SectionTitleFS,'  ')); ?>
</p>
<p>
	<label><?php echo(__('Corps de texte:')); ?></label>
	<?php echo(form::combo('fpdf4dc2_TextFF',$FontFamily,$fpdf4dc2_TextFF)); ?><?php echo(form::field('fpdf4dc2_TextFS',3,255,$fpdf4dc2_TextFS,'  ')); ?>
</p>
<p>
	<label><?php echo(__('Interligne en mm')); ?></label>
	<?php echo(form::field('fpdf4dc2_interligne',3,255,$fpdf4dc2_interligne,'  ')); ?>
</p>
</fieldset>
<br/><br/>
<fieldset>
	
	<legend><b>Positionnement du logo</b></legend>
<p>
	<label><?php echo(__('Position par rapport à bord gauche en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_logoposx',5,255,$fpdf4dc2_logoposx,' ')); ?>
</p>
<p>
	<label><?php echo(__('Position par rapport à bord haut en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_logoposy',5,255,$fpdf4dc2_logoposy,' ')); ?>
</p>
<p>
	<label><?php echo(__('Largeur du logo en mm:')); ?></label>
	<?php echo(form::field('fpdf4dc2_logowidth',5,255,$fpdf4dc2_logowidth,' ')); ?>
</p>
<p>
	<label><?php echo(__('Chemin vers le fichier logo.jpg :')); ?></label>
	<?php echo(form::field('fpdf4dc2_pathtologo',25,255,$fpdf4dc2_pathtologo,'  ')); ?>
</p>

</fieldset>
<br/>


<fieldset>
<legend><b>Couverture</b></legend>

<p><label><?php echo(__('Type de la couverture')); ?></label>
<?php echo(form::combo('fpdf4dc2_typeofcover',$TypeOfCover, $setfpdf4dc2->fpdf4dc2_typeofcover )); ?>
</p>


</fieldset>


<br/>
<p><?php echo $core->formNonce(); ?></p>
<p><input type="submit" name="savemep" value="<?php echo __('Save'); ?>" /></p>
</form>
</div>


<div class="multi-part" id="Fonctionnalites" title="<?php echo __('Fonctionnalités'); ?>">

<form method="post" action="<?php echo($p_url); ?>" >
<br/>
<fieldset>
<legend><b>Activation de Fpdf4dc2</b></legend>
<br/>
<p><?php echo(
	form::checkbox('fpdf4dc2_active','1',$setfpdf4dc2->fpdf4dc2_active).
	' '.__('Enable')); ?></p>
	<p><?php echo $core->formNonce(); ?></p>
 
</fieldset>

<br/><br/>
<table style="width:500px"><tr>
<td>
<fieldset>
	
	<legend><b>Sommaire</b></legend>
	<br/>
    <p><?php echo(
	form::checkbox('fpdf4dc2_sommaireactif','1',$setfpdf4dc2->fpdf4dc2_sommaireactif).
	' '.__('Enable')); ?></p>
	<p><?php echo $core->formNonce(); ?></p>
    

</fieldset>
</td>
<td>
<fieldset>
	
	<legend><b>Ajouter un logo</b></legend>
    <p><?php echo(
	form::checkbox('fpdf4dc2_aveclogo','1',$setfpdf4dc2->fpdf4dc2_aveclogo).
	' '.__('Enable')); ?></p>
	<p><?php echo $core->formNonce(); ?></p>
   
</fieldset>
</td>
<td>
<fieldset>
	
	<legend><b>Page de garde</b></legend>

   <p><?php echo(
	form::checkbox('fpdf4dc2_pagedegarde','1',$setfpdf4dc2->fpdf4dc2_pagedegarde).
	' '.__('Enable')); ?></p>
	<p><?php echo $core->formNonce(); ?></p>
   
</fieldset>
</td>
<td>
<fieldset>

<legend><b>Page de couverture</b></legend>

  <p><?php echo(
	form::checkbox('fpdf4dc2_couverture','1',$setfpdf4dc2->fpdf4dc2_couverture).
	' '.__('Enable')); ?></p>
	<p><?php echo $core->formNonce(); ?></p>
   
</fieldset>
</td>
</tr></table >
<br/>
 <p><input type="submit" name="save_fonction" value="<?php echo __('Save'); ?>" /></p>
</form>

</div>
	
<div class="multi-part" id="Presentation" title="<?php echo __('Présentation'); ?>">
	<p> Fpdf4dc2 génére à la volée un document pdf à partir du contenu d'un ou plusieurs messages du blog</p>
	<p> Le format et l'aspect du document final sont contrôlables via l'interface d'adminitration.</p>
	<p>Le plugin crée la balise {{tpl:PdfRequestButton}} qu'il faut ajouter dans le code des fichiers post.html, page.html, category.html, tags.html</p>
	<p>Une icone PDF apparait alors coté visiteur.</p>
	<p>Un clic produit le pdf d'un article, ou de tous les articles d'une categorie, ou correspondant à une recherche sur mot-clé (tag)</p>
	<br />
	<p> Le code ne gère pas toutes les balises html: </p>
	<p> Les balises traitées sont les suivantes: </p> p,b,u,i,a,img,p,br,code,strong,em,font,tr,blockquote,h1,h2,h3,h4,h5,h6,li,ul,section,aside, figure, caption</p>
	<p> Les autres balises sont simplement ignorées.</p>
    <p> Ce plugin est basée sur la classe FPDF - <?php $core->plugins->moduleInfo('Fpdf4dc2','0.35') ?><img alt="based on fpdf" src="icon_fpdf.png" /></p>
</div>
 

</body>
</html>


